/**
 * This program reads a single line the retard way :P.
 * Copyright (C) 2022  Calico <benoit.dufour@mail.com>
 * 
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(void)
{
    printf("This program reads a single line the retard way :P.\n");
    char *my_input = (char *)malloc(sizeof(char)); // allocated on heap with malloc, could surely be allocated on stack with alloca
    printf("Enter something: ");
    char current_char = getchar();
    int length = 0;
    while (current_char != '\n')
    {
        my_input[length] = current_char;
        length++;
        my_input = realloc(my_input, length * sizeof(char));
        current_char = getchar();
    }
    my_input = realloc(my_input, (length + 1) * sizeof(char));
    my_input[length] = '\0'; // Could be 0 instead of '\0' I guess
    printf("my_input value: %s\n", my_input);
    printf("my_input length (including \\0), calculated by strlen: %zu\n", strlen(my_input) + 1);
    free(my_input); // Never forget to free an allocated variable.
    printf("my_input length (including \\0), from the length variable: %d", length + 1);

    return 0;
}